/**
 * SPDX-License-Identifier: Apache-2.0
 * Copyright (c) uTango Project and Contributors. All rights reserved.
 */

/* FLASH CFG -----------------------------------------------------------------*/
__FLASH_BASE = __FLASH_BASE_W1;
__FLASH_SIZE = __FLASH_SIZE_W1;
/*----------------------------------------------------------------------------*/

/* RAM CFG -------------------------------------------------------------------*/
__RAM_BASE   = __RAM_BASE_W1;
__RAM_SIZE   = __RAM_SIZE_W1;
/*----------------------------------------------------------------------------*/

/* STACK CFG -----------------------------------------------------------------*/
__STACK_SIZE = 0x00000400;
__HEAP_SIZE  = 0x00000C00; /* TODO: heap need for kernel?! */
/*----------------------------------------------------------------------------*/

/* Linker script to configure memory regions. */
MEMORY
{
  FLASH (rx)  : ORIGIN = __FLASH_BASE, LENGTH = __FLASH_SIZE
  RAM   (rwx) : ORIGIN = __RAM_BASE,   LENGTH = __RAM_SIZE
}

ENTRY(Reset_Handler)

SECTIONS
{
    .text :
    {
        KEEP(*(.vectors));
        __Vectors_End = .;
        __Vectors_Size = __Vectors_End - __Vectors;
        __end__ = .;

        *(.text*);
        *(.RODATA*);
    } > FLASH

    .ARM.extab :
    {
        *(.ARM.extab* .gnu.linkonce.armextab.*)
    } > FLASH
    .ARM.exidx :
    {
        *(.ARM.exidx* .gnu.linkonce.armexidx.*)
    } > FLASH

    __etext = .;

    .data :
    {
        . = ALIGN(4);
        __data_start__ = .;

        *(.data*)

        . = ALIGN(4);
        __data_end__ = .;

    } > RAM AT > FLASH

    .bss (NOLOAD):
    {
        . = ALIGN(4);
        __bss_start__ = .;

        *(.bss*)
        *(COMMON)

        . = ALIGN(4);
        __bss_end__ = .;
    } > RAM

    bss_size = __bss_end__ - __bss_start__;

    .stack (ORIGIN(RAM) + LENGTH(RAM) - __STACK_SIZE) (COPY) :
    {
        . = ALIGN(8);
        __Stack_Lim = .;
        . = . + __STACK_SIZE;
        . = ALIGN(8);
        __Stack_Top = .;
    } > RAM
}
